<!--
Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)

SPDX-License-Identifier: AGPL-3.0-or-later
-->
<script setup lang="ts">
import { computed, ref, watch, inject, onMounted, onUnmounted } from 'vue';
import { storeToRefs } from 'pinia';
import { VueDraggable } from 'vue-draggable-plus';
import { useI18n } from 'vue-i18n';
import { paneTypes, userType, handleModeEnum, itemEnum, adminMenuEnum } from '@/enums/enums';
import useShareDBDoc from '@/hooks/useShareDBDoc';
import { useTimelineStore } from '@/stores/timeline';
import BoardInformation from '@/components/general/BoardInformation.vue';
import Modal from '@/components/general/Modal.vue';
import LoadingSpinner from '@/components/general/LoadingSpinner.vue';
import { getCookie } from '@/lib/utils';
import useTimeline from '@/hooks/useTimeline';
import Post from '@/components/timeline/Post.vue';
import LineSegment from '@/components/timeline/LineSegment.vue';
import PostEditor from '@/components/general/PostEditor.vue';
import Comments from '@/components/general/CommentSidebar.vue';
import Favorite from '@/components/general/Favorite.vue';
import Dropdown from '@/components/general/Dropdown.vue';
import AdminMenuButton from '@/components/general/AdminMenu.vue';
import PaneDropdown from '@/components/account/PaneDropdown.vue';
import Button from '@/components/general/Button.vue';


const { t } = useI18n();
const $t = t;

useShareDBDoc(paneTypes.TIMELINE);

const store = useTimelineStore();
const { createPost } = useTimeline();

const { getHeadline, getSubHeadline, getUserType, getStyle, dataSet: getDataSet, getFullUsable, getMovable, postIndex, file, showAdministrationSidebar, handleMode, getLineColor, getLineElementsColor, getLineSize, elementColor, commentIndex, showComments, openMenu } = storeToRefs(store);
let configuration = inject<any>('configuration');
let apiServer = configuration.apiServer;

document.title = $t('general.variables.name');

watch(getHeadline, (headline) => {
    document.title = headline;
})

const containerRef = ref<HTMLDivElement>();
const simulateClick = () => {
    //to close the dropdown menu on drag
    if (containerRef.value)
        containerRef.value.click();
}

const onPostDrag = (e: any) => {
    simulateClick();
    store.editPostPosition({ postIndex: e.oldIndex, newPostIndex: e.newIndex });
}

const checkMove = () => {
    return getMovable.value;
}


const closeComments = () => {
    postIndex.value = -1;
    showComments.value = false;
}

const pasteText = ref('');
const pasteContent = async (event: ClipboardEvent) => {
    if (getFullUsable.value && !showComments.value && openMenu.value !== adminMenuEnum.SETTINGS) {
        let item = event.clipboardData;
        if (item && item.items[0].type.indexOf("image") >= 0) {
            file.value = item.items[0].getAsFile();
        } else if (item && item.items[0].type.indexOf("text") >= 0) {
            //@ts-ignore
            pasteText.value = document.createElement('div').appendChild(document.createTextNode(item.getData("text"))).parentNode!.innerHTML;
        }
        //TODO: save pasted element
    }
};

const isHeadlineModalOpen = ref(false);
const showHeadlineModal = (value: boolean) => {
    isHeadlineModalOpen.value = value;
}

const isSubHeadlineModalOpen = ref(false);
const showSubHeadlineModal = (value: boolean) => {
    isSubHeadlineModalOpen.value = value;
}


const close = () => {
    pasteText.value = '';
    file.value = null;
}

const closeEdit = () => {
    handleMode.value = handleModeEnum.NONE;
}

const addElement = () => {
    elementColor.value = getStyle.value.shapeColors;
    commentIndex.value = -1;
    handleMode.value = handleModeEnum.ADD;
}


const timelineMargin = computed(() => {
    return -getLineSize.value + 2; //-width + 2px;
});

const addButtonMargin = computed(() => {
    return -60 - timelineMargin.value;// -60px - timelineMargin;
})

const getLineStyle = computed(() => {
    return `solid ${getLineSize.value}px ${getLineColor.value}`;
})

const getAddButtonStyle = computed(() => {
    return {
        fontWeight: getLineSize.value >= 5 ? 800 : getLineSize.value >= 3 ? 600 : undefined,
        marginTop: getLineSize.value === 4 ? "-1px" : getLineSize.value === 5 ? "-2px" : undefined,
        marginLeft: getLineSize.value === 5 ? "-3px" : undefined
    };
})

const getFirstLineSegmentStyle = computed(() => {
    return { width: getLineSize.value === 5 ? "62px" : (getLineSize.value === 4 ? "64px" : (getLineSize.value === 3 ? "67px" : (getLineSize.value === 2 ? "69px" : undefined))) };
})

const posts = computed(() => {
    if (getDataSet.value) {
        return getDataSet.value?.map((element: any, index: number) => {
            if ((getUserType.value === userType.USER && (element.visible && element.authorized)) || (getUserType.value !== userType.USER)) {
                return {
                    element,
                    index,
                }
            }
            return { index: -1 };
        });
    }
    return [];
});

const animateOnIndex = ref(-1);
const handleStartMovePost = (evt: any) => {
    simulateClick();
    animateOnIndex.value = evt.oldIndex;
    setTimeout(() => {
        animateOnIndex.value = -1;
    }, 1500)
};

const isTouch = computed(() => {
  return (typeof document !== 'undefined' && 'ontouchstart' in document.documentElement)
});

const startMove = (event) => {
    simulateClick();
    setTimeout(() => {
        event.item.classList.remove('animate-element-wiggle');
        event.item.style.opacity = '0.5';
    }, 200)
}

const resetToDefault = (event) => {
     event.item.style.opacity = '';
}


</script>
<template>
    <div @paste="pasteContent" style="min-width:600px" ref="containerRef" class="min-w-screen max-h-screen">
        <nav class="bg-white min-h-20 max-h-20 h-20 flex flex-row">
            <div class="pl-7 h-20 pt-5">
                <div :class="['select-none', getStyle?.font ? getStyle.font : '']">
                    <Tooltip :tooltip="getHeadline" :offset="10" width="max-w-96">
                        <div class="text-2xl line-clamp-1 text-ellipsis w-full h-7">{{ getHeadline }}</div>
                    </Tooltip>
                    <div class="w-fit">
                        <Tooltip :tooltip="getSubHeadline" placement="bottom" width="max-w-96">
                            <div class="line-clamp-1 text-ellipsis h-6">{{ getSubHeadline }}</div>
                        </Tooltip>
                    </div>
                </div>
            </div>
            <div class="ml-auto min-w-80">
                <div class="flex flex-row min-h-20 max-h-20 h-20 p-4 gap-2 justify-end">
                    <div class="size-12 block hover:bg-gray-200 rounded-md" v-if="getCookie('Token')">
                        <Favorite size="size-12 pt-1" />
                    </div>
                    <Tooltip :tooltip="$t('adminMenu.questionmark.label')">
                        <a class="size-12 hover:bg-gray-200 text-gray-500 rounded-md block text-center align-middle leading-[48px] text-2xl hover:text-gray-500 hover:no-underline"
                            :href="$t('indexPage.faq')" rel="noopener" target="_blank"><i
                                class="ri-question-line leading-12 ri-sm align-middle"></i></a>
                    </Tooltip>
                    <Dropdown placement="bottom-end">
                        <template #button>
                            <Tooltip :tooltip="$t('tooltips.information')">
                                <button
                                    class="size-12 hover:bg-gray-200 text-gray-500 rounded-md block text-center align-middle leading-[48px] text-2xl hover:no-underline"><i
                                        class="ri-information-2-line ri-sm leading-12 align-middle"></i></button>
                            </Tooltip>
                        </template>
                        <BoardInformation cls="w-fit" />
                    </Dropdown>
                    <AdminMenuButton cls="" :name="getHeadline" />
                    <Dropdown placement="bottom-end" width="min-w-64 max-w-64" v-if="getCookie('Token')">
                        <template #button>
                            <Tooltip :tooltip="$t('general.variables.account.sg')">
                                <button
                                    class="size-12 hover:bg-gray-200 text-gray-500 rounded-md block text-center align-middle leading-[48px] text-2xl hover:no-underline"><i
                                        class="ri-user-line leading-12 ri-sm align-middle"></i></button>
                            </Tooltip>
                        </template>
                        <template v-slot="{ close }">
                            <PaneDropdown :close="close" />
                        </template>
                    </Dropdown>
                </div>
            </div>
        </nav>
        <div id="content" class="box-border h-[calc(100dvh-80px)] max-h-[calc(100dvh-80px)] overflow-auto select-none"
            :class="[getStyle?.font ? getStyle.font : '']"
            :style="{ background: getStyle != null && getStyle.backgroundImage != null ? `url(${apiServer}` + getStyle.backgroundImage + ')' : (getStyle != null && getStyle.backgroundColor != null ? getStyle.backgroundColor : 'white') }">
            <div class="flex flex-row flex-nowrap w-full top-1/2 relative h-1 min-w-screen gap-2 pt-1"
                :style="[{ '--addColor': getLineElementsColor }, { '--addColorHover': getLineElementsColor + 40 }, { '--timelineMargin': timelineMargin + 'px' }, { '--buttonMargin': addButtonMargin + 'px' }, { '--lineStyle': getLineStyle }]">
                <div class="timeline-line-first w-16 max-w-16 min-w-16 h-0"></div>
                <template v-for="(element, n) in getDataSet">
                    <LineSegment :segmentIndex="n"
                        v-if="(getUserType === userType.USER && (element.visible && element.authorized)) || (getUserType !== userType.USER)" />
                </template>
                <div class="-top-4 relative inline size-8 mt-0 z-[998]" v-if="getFullUsable">
                    <Tooltip :tooltip="$t('contentPage.post.add')" :style="getAddButtonStyle">
                        <button class="last-add rounded-md inline w-8 z-[11]" @click="addElement">
                            <strong class="text-center relative block"><i class="ri-add-line text-3xl"></i></strong>
                        </button>
                    </Tooltip>
                </div>
                <div class="timeline-line-extend h-0 grow min-w-16"></div>
            </div>
            <div class="flex flex-row flex-nowrap w-full relative gap-2">
                <div class="w-16 max-w-16 min-w-16 h-0"></div>
                <VueDraggable class="flex flex-row flex-nowrap w-full relative gap-2" @end="onPostDrag"
                    :modelValue="posts" handle=".header-handle" :move="checkMove" :animation="250" :delay="250"
                    :delayOnTouchOnly=true @start="startMove" :dragClass="isTouch? 'hidden' : ''" :chosenClass="isTouch? 'animate-element-wiggle' : ''" :onUnchoose="resetToDefault">
                    <Post :key="element.id" :post="element.element" :postIndex="element.index" :postCount="getDataSet!.length"
                       v-for="(element, index) in posts"/>
                </VueDraggable>
            </div>
            <div class="inline fixed bottom-4 right-4 z-[999] w-fit" v-if="getFullUsable">
                <Tooltip :tooltip="$t('contentPage.post.add')">
                    <Button variant="accent2" @click="addElement"><i
                            class="ri-add-line text-2xl leading-10"></i></Button>
                </Tooltip>
            </div>
            <LoadingSpinner />
            <Comments @close="closeComments" v-if="postIndex > -1 && showComments" />
            <Modal v-if="isHeadlineModalOpen" @close="showHeadlineModal(false)"
                :labelCancel="$t('general.buttons.close')">
                <div class="text-xl" v-html="getHeadline"></div>
            </Modal>
            <Modal v-if="isSubHeadlineModalOpen" @close="showSubHeadlineModal(false)"
                :labelCancel="$t('general.buttons.close')">
                <div class="text-lg" v-html="getSubHeadline"></div>
            </Modal>
            <PostEditor v-if="handleMode === handleModeEnum.ADD || handleMode === handleModeEnum.EDIT"
                @close="closeEdit" />
        </div>
    </div>
</template>
<style scoped>
.display-none {
    display: none;
}

.last-add {
    /*margin-left: var(--buttonMargin);*/
    color: var(--addColor);
}

.last-add:hover {
    background-color: var(--addColorHover);
}

.timeline-line-extend {
    /*margin-top: var(--timelineMargin);*/
    border: var(--lineStyle);
}

.timeline-line-first {
    /*margin-top: var(--timelineMargin);*/
    border: var(--lineStyle);
}

::-webkit-scrollbar {
    position: absolute;
    width: 6px;
}

.animate-element-wiggle {
    opacity: 0.5;
    animation: wiggle 1.5s linear;
}

.animate-element {
    opacity: 0.5;
}

.ghostClass {
    opacity: 0;
}

@keyframes wiggle {

    0%,
    7% {
        transform: rotateZ(0);
    }

    15% {
        transform: rotateZ(-5deg);
    }

    20% {
        transform: rotateZ(3deg);
    }

    25% {
        transform: rotateZ(-3deg);
    }

    30% {
        transform: rotateZ(2deg);
    }

    35% {
        transform: rotateZ(-1deg);
    }

    40%,
    100% {
        transform: rotateZ(0);
    }
}
</style>